// import '../models/media.dart';
// import '../models/market.dart';
import 'package:ecom_widgets/helpers/custom_trace.dart';

class Slide {
  late String id;
  late int order;
  late String text;
  late String subTitle;
  late String button;
  late String textPosition;
  late String textColor;
  late String buttonColor;
  late String backgroundColor;
  late String indicatorColor;
  late String image;
  late String imageFit;
  // Market market;
  bool enabled = false;

  Slide();

  Slide.fromJSON(Map<String, dynamic> jsonMap) {
    try {
      id = jsonMap['id'].toString();
      order = jsonMap['order'] != null ? jsonMap['order'] : 0;
      text = jsonMap['text'] != null ? jsonMap['text'].toString() : '';
      button = jsonMap['button'] != null ? jsonMap['button'].toString() : '';
      textPosition = jsonMap['text_position'] != null
          ? jsonMap['text_position'].toString()
          : '';
      textColor =
          jsonMap['text_color'] != null ? jsonMap['text_color'].toString() : '';
      buttonColor = jsonMap['button_color'] != null
          ? jsonMap['button_color'].toString()
          : '';
      backgroundColor = jsonMap['background_color'] != null
          ? jsonMap['background_color'].toString()
          : '';
      indicatorColor = jsonMap['indicator_color'] != null
          ? jsonMap['indicator_color'].toString()
          : '';
      imageFit = jsonMap['image_fit'] != null
          ? jsonMap['image_fit'].toString()
          : 'cover';
      enabled = jsonMap['enabled'] ?? false;
      subTitle = jsonMap['sub_title'] != null ? jsonMap['sub_title'] : "";

      image = jsonMap['image'] != null ? jsonMap['image'].toString() : '';
    } catch (e) {
      id = '';
      order = 0;
      text = '';
      button = '';
      textPosition = '';
      textColor = '';
      buttonColor = '';
      backgroundColor = '';
      indicatorColor = '';
      imageFit = '';
      enabled = false;
      // market = Market.fromJSON({});
      image = "";
      print(CustomTrace(StackTrace.current, message: e.toString()));
    }
  }

  Map toMap() {
    var map = new Map<String, dynamic>();
    map["id"] = id;
    map["text"] = text;
    map["order"] = order;
    map["button"] = button;
    map["text_position"] = textPosition;
    map["text_color"] = textColor;
    map["button_color"] = buttonColor;
    return map;
  }

  @override
  bool operator ==(dynamic other) {
    return other.id == this.id;
  }

  @override
  int get hashCode => this.id.hashCode;
}
