import 'dart:async';

import 'package:ecom_widgets/models/firebase_token.dart';
import 'package:ecom_widgets/services/firebase_token_service.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:get_storage/get_storage.dart';

class AuthProvider extends ChangeNotifier {
  final BuildContext? context;

  AuthProvider({this.context}) {
    print('registerFirebaseCallbacks');
    registerFirebaseCallbacks();
  }
  bool isAuthenticated = false;

  void setAuthentication(bool isAuthenticated) {
    this.isAuthenticated = isAuthenticated;
    notifyListeners();
  }

  listenF(User? user) async {
    GetStorage box = GetStorage();
    if (user == null) {
      GetStorage().erase();
      setAuthentication(false);
    } else {
      var idToken = await user.getIdToken();
      box.write("token", idToken);
      box.write("displayName", user.displayName);
      box.write("email", user.email);
      box.write("phoneNumber", user.phoneNumber);
      box.write("photoURL", user.photoURL);

      {
        String? value = await FirebaseMessaging.instance.getToken();

        FirebaseToken token = FirebaseToken.fromJson({"token": value});
        await FirebaseTokenService().createFirebaseToken(token);
      }

      setAuthentication(true);
      Fluttertoast.showToast(
        msg: 'Logged In',
      );
    }
  }

  static StreamSubscription<User?>? sub;
  registerFirebaseCallbacks() {
    // User changed callback
    if (sub != null) sub!.cancel();
    sub = FirebaseAuth.instance.authStateChanges().listen(listenF);

    // FirebaseAuth.instance.authStateChanges().listen(listenF);

    // Token changed callback
    FirebaseAuth.instance.idTokenChanges().listen((User? user) async {
      if (user == null) {
        GetStorage().erase();
        setAuthentication(false);
      } else {
        GetStorage box = GetStorage();
        var idToken = await user.getIdToken();
        box.write("token", idToken);
        box.write("displayName", user.displayName);
        box.write("email", user.email);
        box.write("phoneNumber", user.phoneNumber);
        box.write("photoURL", user.photoURL);
        setAuthentication(true);
      }
    });
  }
}
