import 'package:flutter/material.dart';

class SheetWidget extends StatefulWidget {
  // final GlobalKey<ScaffoldState> scaffoldKey;
  final List<Widget> children;
  SheetWidget({Key? key, required this.children}) : super(key: key);

  @override
  _SheetWidgetState createState() => _SheetWidgetState();
}

class _SheetWidgetState extends State<SheetWidget> {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 350,
      decoration: BoxDecoration(
        color: Theme.of(context).backgroundColor,
        borderRadius: BorderRadius.only(
            topRight: Radius.circular(20), topLeft: Radius.circular(20)),
        boxShadow: [
          BoxShadow(
              color: Theme.of(context).focusColor.withOpacity(0.4),
              blurRadius: 30,
              offset: Offset(0, -30)),
        ],
      ),
      child: Stack(children: [
        Padding(
          padding: const EdgeInsets.only(top: 30),
          child: ListView(
            padding: EdgeInsets.only(top: 20, bottom: 15, left: 20, right: 20),
            children: [
              ...widget.children,
            ],
          ),
        ),
        Container(
          height: 30,
          width: double.infinity,
          padding: EdgeInsets.symmetric(
            vertical: 13,
            horizontal: MediaQuery.of(context).size.width,
          ),
          decoration: BoxDecoration(
            color: Theme.of(context).focusColor.withOpacity(0.05),
            borderRadius: BorderRadius.only(
                topRight: Radius.circular(20), topLeft: Radius.circular(20)),
          ),
          child: Container(
            width: 30,
            decoration: BoxDecoration(
              color: Theme.of(context).focusColor.withOpacity(0.8),
              borderRadius: BorderRadius.circular(3),
            ),
            //child: SizedBox(height: 1,),
          ),
        ),
      ]),
    );
  }
}
